'use strict';

function replaceAll(str, stringOrRegexp, replaceValue) {
  // 比较新版本的浏览器中字符串自带replaceAll方法，但是编辑器内置的没有。
  let previousResult = null;
  let newResult = str;
  // 替换到结果不变为止。
  do {
    previousResult = newResult;
    newResult = previousResult.replace(stringOrRegexp, replaceValue);
  } while (newResult != previousResult);
  return newResult;
}

function sanitizeUserParam(param) {
  // 净化用户输入的参数，具体的，我们的参数会插入到两个单引号中，
  // 用户输入不应该破坏引号的平衡。
  // 首先需要去掉单引号和斜杠（正常参数内容不会出现单引号以及斜杠）。
  // 不需要去掉注释符：//以及/*，因为在单引号中，这些符号不会有特殊意义。
  // 由于只需要去掉单引号和斜杠，不会引入新的有问题的字符，故不用递归执行。
  return replaceAll(param, /'|\\/, '');
}

exports.sanitizeUserParam = sanitizeUserParam;
